﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr155_1
{
    // Абстрактный класс: 
    abstract class Base {
        // Абстрактное текстовое свойство: 
        public abstract string text { 
            get; set;
        }
        // Абстрактный индексатор с целочисленным индексом: 
        public abstract char this[int k] { 
            get;
        }
        // Абстрактное целочисленное свойство: 
        public abstract int length { 
            get;
        }
    }
    // Производный класс на основе абстрактного: 
    class Alpha: Base {
        // Закрытое поле, являющееся ссылкой на массив: 
        private char[] symbs;
        // Конструктор:
        public Alpha(string t): base() {
            // Текстовому свойству присваивается значение: 
            text = t;
        }
        // Переопределение текстового свойства: 
        public override string text {
            get {
                // Результатом является текстовая строка: 
                return new string(symbs);
            }
            set {
                // Создание символьного массива и присваивание 
                // значения полю: 
                symbs = value.ToCharArray();
            }
        }
        // Переопределение целочисленного свойства: 
        public override int length { 
            get {
                // Размер массива: 
                return symbs.Length;
            }
        }
        // Переопределение индексатора: 
        public override char this[int k] { 
            get {
                // Значение элемента символьного массива: 
                return symbs[k];
            }
        }
    }

    // Производный класс на основе абстрактного: 
    class Bravo: Base {
        // Закрытое текстовое поле: 
        private string txt;
        // Конструктор:
        public Bravo(string t): base() {
            // Текстовому свойству присваивается значение:
            text = t;
        }
        // Переопределение текстового свойства: 
        public override string text { 
            get {
                // Значение поля: 
                return txt;
            }
            set {
                // Присваивание значения полю: 
                txt = value;
            }
        }
        // Переопределение целочисленного свойства: 
        public override int length { 
            get {
                // Количество символов в тексте: 
                return txt.Length;
            }
        }
        // Переопределение индексатора: 
        public override char this[int k] { 
            get {
                // Символ в тексте: 
                return txt[k];
            }
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Ссылка на объект производного класса записывается 
            // в объектную переменную базового класса:
            Base obj = new Alpha("Alpha");
            // Отображение значения текстового свойства:
            Console.WriteLine(obj.text);
            // Новое значение текстового свойства: 
            obj.text = "Base";
            // Индексирование объекта: 
            for(int k = 0;k < obj.length; k++) {
                Console.Write("|" + obj[k]);
            }
            Console.WriteLine("|");
            // Ссылка на объект производного класса записывается 
            // в объектную переменную базового класса: 
            obj = new Bravo("Bravo");
            // Индексирование объекта: 
            for(int k = 0;k < obj.length; k++) {
                Console.Write("|" + obj[k]);
            }
            Console.WriteLine("|");
            // Новое значение текстового свойства: 
            obj.text = "Base";
            // Отображение значения текстового свойства:
            Console.WriteLine(obj.text);
            // Задержка:
            Console.ReadLine();
        }
    }
}
